'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ReduxFocus = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactReduxRestate = require('react-redux-restate');

var _reactReduxRestate2 = _interopRequireDefault(_reactReduxRestate);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var dispatchDefault = function dispatchDefault(dispatch, event) {
  return dispatch(event);
};

var SECRET = '__focus_secret';
var RenderChildren = function RenderChildren(_ref) {
  var children = _ref.children;
  return children;
};

var focus = function focus(composeState) {
  var onDispatch = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : dispatchDefault;
  var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  return function (WrappedComponent) {
    return (0, _reactReduxRestate2.default)({}, function (stores, props) {
      return composeState(stores.default, props);
    }, function (dispatchers, event, props) {
      return onDispatch(dispatchers.default, event, props);
    }, function () {
      return _extends({}, options, {
        ignoreProps: [SECRET, 'componentProps', 'focus', 'onDispatch'],
        deeperProps: ['componentProps']
      });
    })(WrappedComponent);
  };
};

// Component model
var ComponentFocus = focus(function (store, props) {
  return props[SECRET].composeState(store, props);
}, function (dispatcher, event, props) {
  return props[SECRET].onDispatch(dispatcher, event, props);
})(RenderChildren);

var focusSecret = _defineProperty({}, SECRET, {
  composeState: function composeState(store, props) {
    return props.focus(store, props.componentProps);
  },
  dispatch: function dispatch(dispatcher, event, props) {
    return props.onDispatch(dispatcher, event, props.componentProps);
  }
});

var ReduxFocus = function ReduxFocus(_ref2) {
  var focus = _ref2.focus,
      onDispatch = _ref2.onDispatch,
      children = _ref2.children,
      rest = _objectWithoutProperties(_ref2, ['focus', 'onDispatch', 'children']);

  return _react2.default.createElement(
    ComponentFocus,
    _extends({}, focusSecret, { focus: focus, onDispatch: onDispatch, componentProps: rest }),
    children
  );
};

ReduxFocus.propTypes = {
  focus: _propTypes2.default.func.isRequired,
  onDispatch: _propTypes2.default.func,
  children: _propTypes2.default.node
};

exports.ReduxFocus = ReduxFocus;
exports.default = focus;